diff --git a/src/w32term.c b/src/w32term.c
index bb1f0ba..62b1baa 100644
--- a/src/w32term.c
+++ b/src/w32term.c
@@ -545,6 +1417,15 @@ x_update_begin (struct frame *f)
   if (! FRAME_W32_P (f))
     return;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = f;
+
+/* *************************************************************************** */
+
+
   /* Regenerate display palette before drawing if list of requested
      colors has changed. */
   if (display_info->regen_palette)
@@ -754,6 +1635,16 @@ x_update_end (struct frame *f)
 
   /* Mouse highlight may be displayed again.  */
   MOUSE_HL_INFO (f)->mouse_face_defer = false;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = NULL;
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -4041,13 +4932,74 @@ w32_set_vertical_scroll_bar (struct window *w,
 	      release_frame_dc (f, hdc);
 	      x_clear_under_internal_border (f);
 	    }
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* REPAINTING WHEN REMOVING SCROLL BAR:
+
+- Sequence of Events:
+
+  . `redisplay_internal' calls the `condemn_scroll_bars_hook', which marks all
+    scroll bars as candidates for deletion.
+
+  . Then `redisplay_internal' calls `redisplay_windows', which walks the
+    window-tree and examines each window, whereby each window that is still alive
+    in the window-tree "redeems" its scroll bars by marking them not to be
+    deleted.
+
+  . Then `redisplay_internal' calls `judge_scroll_bars_hook', which removes all
+    the scroll bars that were not "redeemed".
+
+  . And only after that `redisplay_internal' calls `update_frame', which calls
+    `update_window' for each live window, and that ends up calling `draw_glyphs'
+    to deliver the updated contents to the glass.
+
+- Observations by @lawlist:
+
+  . Although the call to remove/add scroll bars happens earlier in time, it is
+    not actually processed by Emacs until the tail end of `read_char', at
+    approximately when the call to `read_decoded_event_from_main_queue' occurs.
+
+  . Although a scroll bar may no longer be visible because it was overwritten
+    during `update_window', Emacs tries to remove the outdated scroll bar
+    anyway and that is what erases the fake cursors along the rectangle of the
+    vertical scroll bar.
+
+  . At about the exact same time that the scroll bar in the center of the screen
+    gets erased, the right scroll bar on the far right of the window is added.
+
+- The external function `MoveWindow' (by Microsoft) updates both the old and new
+  rectangles/windows if the boolean argument for `bRepaint` is TRUE.
+
+- The external function `DestroyWindow' (by Microsoft) updates/repaints the
+  rectangle/window that is removed.  [In experimenting with `LockWindowUpdate'
+  (by Microsoft), @lawlist was unable to prevent the update/repaint.]
+
+- The external function `SetWindowPos' (by Microsoft) updates/repaints the
+  rectangle/window that is removed.  @lawlist has not yet experimented with
+  altering the last argument uFlags to see if it is possible to prevent update /
+  repaint.
+
+When a user enlarges the width of a main window, `update_window' redraws the
+screen lines and the old scroll bar window is erased in the process by a
+combination of `draw_glyphs' and `x_clear_end_of_line'.  In that situation, the
+old `bar->left` will be less-than the new `left` scroll bar coordinate.  In order
+to preserve the fake cursors that were laid during `update_window' when
+(left > bar->left), we want to suppress repainting the old scroll.  When a user
+shrinks the width of a window, we want to repaint so that the new scroll bar
+window is updated. */
+
           /* Make sure scroll bar is "visible" before moving, to ensure the
              area of the parent window now exposed will be refreshed.  */
-          my_show_window (f, hwnd, SW_HIDE);
-/**           MoveWindow (hwnd, left, top, width, max (height, 1), TRUE); **/
-	  /* Try to not draw over child frames.  */
-	  SetWindowPos (hwnd, HWND_BOTTOM, left, top, width, max (height, 1),
-                        SWP_FRAMECHANGED);
+          if (left <= bar->left)
+            my_show_window (f, hwnd, SW_HIDE);
+          MoveWindow (hwnd, left, top, width, max (height, 1), left <= bar->left);
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
 
 	  si.cbSize = sizeof (si);
 	  si.fMask = SIF_RANGE;
@@ -4316,6 +5268,21 @@ w32_judge_scroll_bars (struct frame *f)
     {
       struct scroll_bar *b = XSCROLL_BAR (bar);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      /* `DestroyWindow' within `x_scroll_bar_remove' repaints the rectangle.
+      Therefore, we first send a message to inhibit repainting. */
+      if (!WINDOW_LIVE_P (b->window))
+        {
+          HWND hwnd = SCROLL_BAR_W32_WINDOW (b);
+          SendMessage (hwnd, WM_SETREDRAW, false, 0);
+        }
+
+/* *************************************************************************** */
+
+
       x_scroll_bar_remove (b);
 
       next = b->next;
@@ -7091,6 +8058,20 @@ extern frame_parm_handler w32_frame_parm_handlers[];
 
 static struct redisplay_interface w32_redisplay_interface =
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `w32term.c` must be in the exact same order as the
+`redisplay_interface' in `dispextern.h`! */
+
+  mc_w32_draw_window_cursor,
+  mc_w32_draw_glyph_string,
+
+/* *************************************************************************** */
+
+
   w32_frame_parm_handlers,
   x_produce_glyphs,
   x_write_glyphs,
diff --git a/src/window.h b/src/window.h
index fdef407..2b0b9b4 100644
--- a/src/window.h
+++ b/src/window.h
@@ -324,6 +324,147 @@ struct window
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* Suffixes for the `mc` window pointer prefix. */
+struct multiple_cursors
+{
+  /* The recorded pixel width of the last line number drawn during redisplay */
+  int lnum_pixel_width;
+} mc;
+
+struct mc_matrix
+{
+  ptrdiff_t vpos_allocated;
+  ptrdiff_t vpos_used;
+  ptrdiff_t cursors_used[4];
+  enum mc_cache_type
+  {
+    MC_CACHE,
+    CH_CACHE,
+    FC_CACHE,
+    NO_CACHE
+  } cache_type;
+  struct mc_vpos
+  {
+    ptrdiff_t cache_allocated[4];
+    ptrdiff_t cache_used[4];
+    struct mc_contents
+    {
+      bool_bf same_p : 1;
+      struct glyph glyph;
+      int x;
+      int fx;
+      int y;
+      int fy;
+      int hpos;
+      int vpos;
+      int wd;
+      int h;
+      enum mc_cursor_type
+      {
+        /* NOTE:  The fringe bitmap framework relies upon MC_NO_FRINGE_BITMAP
+        having a value of zero (0). */
+        MC_NO_FRINGE_BITMAP,
+        MC_NO_CURSOR,
+        MC_RIGHT_FRINGE_BITMAP,
+        MC_LEFT_FRINGE_BITMAP,
+        MC_FRAMED_BOX,
+        MC_FILLED_BOX,
+        MC_HOLLOW_BOX,
+        MC_BAR,
+        MC_HBAR
+      } cursor_type;
+      int cursor_width;
+      struct mc_RGB
+      {
+        double red;
+        double green;
+        double blue;
+      } fg, bg;
+      bool_bf active_p : 1;
+      enum mc_flavor
+      {
+        NO_FLAVOR,
+        MC_GLYPH,
+        MC_GLYPHLESS,
+        MC_OVERLAY_ARROW_BITMAP,
+        MC_PILCROW,
+        MC_HOLLOW_RECTANGLE_RIGHT_ARROW,
+        MC_REVERSED_HOLLOW_RECTANGLE_RIGHT_ARROW,
+        MC_HOLLOW_RECTANGLE,
+        MC_VERTICAL_BAR_RIGHT_ARROW,
+        MC_REVERSED_VERTICAL_BAR_RIGHT_ARROW,
+        MC_VERTICAL_BAR,
+        MC_REVERSED_VERTICAL_BAR,
+        MC_VERTICAL_BAR_BACKSLASH
+      } glyph_flavor;
+      bool_bf enabled_p : 1;
+    } *cache[4];
+  } *vpos;
+  /* Used elsewhere. */
+  struct mc_essentials
+  {
+    enum mc_row_position
+    {
+      PRE_ZV,
+      AT_ZV,
+      POST_ZV
+    } row_position;
+    bool_bf active_p : 1;
+    struct mc_RGB ch_fg[3], fc_fg[3], sp_fg;
+    int fc_x;
+    int zv;
+    int zv_byte;
+  } essentials;
+  /* Used elsewhere. */
+  enum mc_engine_type
+  {
+    MULTIPLE_CURSORS,
+    HORIZONTAL_RULER,
+    VERTICAL_RULER,
+    FILL_COLUMN,
+    CURSOR_INDICATOR
+  } action_type;
+  /* Used elsewhere. */
+  enum mc_pre_scroll_clean_type
+  {
+    TRY_WINDOW_REUSING_CURRENT_MATRIX_DOWN,
+    TRY_WINDOW_REUSING_CURRENT_MATRIX_UP,
+    TRY_WINDOW_ID
+  } mc_pre_scroll_clean_type__from_where;
+  /* Used elsewhere. */
+  enum mc_draw_row_type
+  {
+    NOWHERE,
+    SCRIBE_ONE,
+    SCRIBE_TWO,
+    SCRIBE_THREE,
+    SKIPPED,
+    POST_CHANGED,
+    UNCHANGED,
+    SET_CURSOR_ONE,
+    SET_CURSOR_TWO
+  } mc_draw_row_type__from_where;
+  /* Used elsewhere. */
+  enum mc_redraw_row_type
+  {
+    UPDATE_WINDOW__REDRAW_OVERLAPPED_ROWS,
+    X_INSERT_GLYPHS,
+    X_FIX_OVERLAPPING_AREA,
+    DRAW_ROW_WITH_MOUSE_FACE,
+    EXPOSE_AREA_ONE,
+    EXPOSE_AREA_TWO,
+    EXPOSE_LINE
+  } mc_redraw_row_type__from_where;
+} mc_matrix;
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
     /* Cursor type of last cursor drawn on the window.  */
     enum text_cursor_kinds phys_cursor_type;
 
diff --git a/src/xdisp.c b/src/xdisp.c
index a88fc69..de64f25 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -13395,6 +18036,69 @@ hscroll_window_tree (Lisp_Object window)
 	      else
 		pt = clip_to_bounds (BEGV, marker_position (w->pointm), ZV);
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* (gdb) bt
+#0  terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at emacs.c:359
+#1  0x00000001001ee996 in die (
+    msg=0x10032fc88 "charpos < 0 || (charpos >= BUF_BEG (current_buffer) && charpos <= ZV)", file=0x10032e32d "xdisp.c", line=7951) at alloc.c:7214
+#2  0x000000010004d2ab in init_iterator (it=0x7fff5fbf9e80, w=0x11ae62150,
+    charpos=743, bytepos=743, row=0x0, base_face_id=DEFAULT_FACE_ID)
+    at xdisp.c:7950
+#3  0x000000010004efc9 in init_from_display_pos (it=0x7fff5fbf9e80,
+    w=0x11ae62150, pos=0x11f9c0250) at xdisp.c:8404
+#4  0x000000010004f546 in init_to_row_start (it=0x7fff5fbf9e80, w=0x11ae62150,
+    row=0x11f9c0200) at xdisp.c:8528
+#5  0x000000010006e536 in hscroll_window_tree (window=...) at xdisp.c:18619
+*/
+
+/* (gdb) bt
+#0  terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at emacs.c:359
+#1  0x00000001001ecbc6 in die (
+    msg=0x10032fad8 "CHARPOS (pos) >= BEGV && CHARPOS (pos) <= ZV",
+    file=0x10032c49d "xdisp.c", line=11746) at alloc.c:7214
+#2  0x000000010005885d in reseat_1 (it=0x7fff5fbf9e30, pos=...,
+    set_stop_p=false) at xdisp.c:11746
+#3  0x0000000100058707 in reseat (it=0x7fff5fbf9e30, pos=..., force_p=true)
+    at xdisp.c:11698
+#4  0x000000010004c732 in init_iterator (it=0x7fff5fbf9e30, w=0x11bf72c98,
+    charpos=114549, bytepos=114549, row=0x0, base_face_id=DEFAULT_FACE_ID)
+    at xdisp.c:8143
+#5  0x000000010004ce01 in init_from_display_pos (it=0x7fff5fbf9e30,
+    w=0x11bf72c98, pos=0x121243d50) at xdisp.c:8299
+#6  0x000000010004d37e in init_to_row_start (it=0x7fff5fbf9e30, w=0x11bf72c98,
+    row=0x121243d00) at xdisp.c:8423
+#7  0x000000010006c3f7 in hscroll_window_tree (window=...) at xdisp.c:18546
+*/
+
+  /* `init_iterator':  eassert (charpos < 0
+                                || (charpos >= BUF_BEG (current_buffer)
+                                    && charpos <= ZV)); */
+
+  struct display_pos *pos = &cursor_row->start;
+  ptrdiff_t charpos = CHARPOS (pos->pos);
+
+  bool barf_crash_one = (charpos < 0
+                         || (charpos >= BUF_BEG (current_buffer)
+                             && charpos <= ZV))
+                        ? false
+                        : true;
+  if (barf_crash_one)
+    return hscrolled_p;
+
+  /* `reseat_1':  CHARPOS (pos) >= BEGV && CHARPOS (pos) <= ZV */
+  bool barf_crash_two = (charpos >= BEGV && charpos <= ZV)
+                         ? false
+                         : true;
+  if (barf_crash_two)
+    return hscrolled_p;
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 	      /* Move iterator to pt starting at cursor_row->start in
 		 a line with infinite width.  */
 	      init_to_row_start (&it, w, cursor_row);
@@ -14287,9 +18991,22 @@ redisplay_internal (void)
 	      *w->desired_matrix->method = 0;
 	      debug_method_add (w, "optimization 1");
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
 #ifdef HAVE_WINDOW_SYSTEM
+  if (BUFFERP (w->contents)
+      && !NILP (BVAR (XBUFFER (w->contents), crosshairs)))
+    mc_update_window_fringes (w, false);
+    else
 	      update_window_fringes (w, false);
 #endif
+
+/* *************************************************************************** */
+
+
 	      goto update;
 	    }
 	  else
@@ -17687,10 +22404,22 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
     }
 
 #ifdef HAVE_WINDOW_SYSTEM
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  bool keep_current_p = (just_this_one_p
+                         || (!used_current_matrix_p && !overlay_arrow_seen)
+                         || w->pseudo_window_p);
+
+  bool fringes_updated_p = (BUFFERP (w->contents)
+                            && !NILP (BVAR (XBUFFER (w->contents), crosshairs)))
+                           ? mc_update_window_fringes (w, keep_current_p)
+                           : update_window_fringes (w, keep_current_p);
+
   if (FRAME_WINDOW_P (f)
-      && update_window_fringes (w, (just_this_one_p
-				    || (!used_current_matrix_p && !overlay_arrow_seen)
-				    || w->pseudo_window_p)))
+      && fringes_updated_p)
     {
       update_begin (f);
       block_input ();
@@ -17705,6 +22434,9 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
       update_end (f);
     }
 
+/* *************************************************************************** */
+
+
   if (WINDOW_BOTTOM_DIVIDER_WIDTH (w))
     x_draw_bottom_divider (w);
 #endif /* HAVE_WINDOW_SYSTEM */
@@ -18010,6 +22742,7 @@ try_window_reusing_current_matrix (struct window *w)
 	     scroll_run_hook will clear the cursor, and use the
 	     current matrix to get the height of the row the cursor is
 	     in.  */
+
 	  run.current_y = start_row->y;
 	  run.desired_y = it.current_y;
 	  run.height = it.last_visible_y - it.current_y;
@@ -18019,6 +22752,16 @@ try_window_reusing_current_matrix (struct window *w)
 	      update_begin (f);
 	      FRAME_RIF (f)->update_window_begin_hook (w);
 	      FRAME_RIF (f)->clear_window_mouse_face (w);
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    mc_pre_scroll_clean (w, run, start_vpos, nrows_scrolled, TRY_WINDOW_REUSING_CURRENT_MATRIX_DOWN);
+
+/* *************************************************************************** */
+
+
 	      FRAME_RIF (f)->scroll_run_hook (w, &run);
 	      FRAME_RIF (f)->update_window_end_hook (w, false, false);
 	      update_end (f);
@@ -18173,6 +22916,7 @@ try_window_reusing_current_matrix (struct window *w)
 	}
 
       /* Scroll the display.  */
+
       run.current_y = first_reusable_row->y;
       run.desired_y = WINDOW_HEADER_LINE_HEIGHT (w);
       run.height = it.last_visible_y - run.current_y;
@@ -18183,6 +22927,16 @@ try_window_reusing_current_matrix (struct window *w)
 	  update_begin (f);
 	  FRAME_RIF (f)->update_window_begin_hook (w);
 	  FRAME_RIF (f)->clear_window_mouse_face (w);
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    mc_pre_scroll_clean (w, run, start_vpos, nrows_scrolled, TRY_WINDOW_REUSING_CURRENT_MATRIX_UP);
+
+/* *************************************************************************** */
+
+
 	  FRAME_RIF (f)->scroll_run_hook (w, &run);
 	  FRAME_RIF (f)->update_window_end_hook (w, false, false);
 	  update_end (f);
@@ -19127,6 +23881,7 @@ try_window_id (struct window *w)
   /* Scroll the display.  Do it before changing the current matrix so
      that xterm.c doesn't get confused about where the cursor glyph is
      found.  */
+
   if (dy && run.height)
     {
       update_begin (f);
@@ -19135,6 +23890,16 @@ try_window_id (struct window *w)
 	{
 	  FRAME_RIF (f)->update_window_begin_hook (w);
 	  FRAME_RIF (f)->clear_window_mouse_face (w);
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    mc_pre_scroll_clean (w, run, first_unchanged_at_end_vpos, dvpos, TRY_WINDOW_ID);
+
+/* *************************************************************************** */
+
+
 	  FRAME_RIF (f)->scroll_run_hook (w, &run);
 	  FRAME_RIF (f)->update_window_end_hook (w, false, false);
 	}
@@ -21273,6 +26038,17 @@ maybe_produce_line_number (struct it *it)
       SET_TEXT_POS (tem_it.position, -1, -1);
       PRODUCE_GLYPHS (&tem_it);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      /* This permits us to inspect the HPOS of line number glyphs and the space
+      padding before/after the line numbers.  We set `glyph->hpos` elsewhere. */
+      tem_it.hpos += 1;
+
+/* *************************************************************************** */
+
+
       /* Stop producing glyphs, and refrain from producing the line
 	 number, if we don't have enough space on this line.  */
       if (tem_it.current_x >= width_limit)
@@ -21284,6 +26060,30 @@ maybe_produce_line_number (struct it *it)
 	}
     }
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  Lisp_Object buf = it->w->contents;
+  CHECK_BUFFER (buf);
+  struct buffer *b = XBUFFER (buf);
+  struct buffer *old_buffer = NULL;
+  /* Needed so that buffer-local values can be determined; e.g., when switching
+  to the minibuffer. */
+  if (b != current_buffer)
+    {
+      old_buffer = current_buffer;
+      set_buffer_internal (b);
+    }
+  it->w->mc.lnum_pixel_width = (!NILP (Vdisplay_line_numbers))
+                               ? tem_it.current_x
+                               : 0;
+  if (old_buffer)
+    set_buffer_internal (old_buffer);
+
+/* *************************************************************************** */
+
+
   /* Record the width in pixels we need for the line number display.  */
   it->lnum_pixel_width = tem_it.current_x;
   /* Copy the produced glyphs into IT's glyph_row.  */
@@ -27092,6 +31892,17 @@ append_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       if (it->pixel_width > 0)
@@ -27175,6 +31986,17 @@ append_composite_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[it->area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
       glyph->charpos = it->cmp_it.charpos;
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -27383,6 +32205,17 @@ produce_image_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27486,6 +32319,17 @@ produce_xwidget_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27572,6 +32416,17 @@ append_stretch_glyph (struct it *it, Lisp_Object object,
 	    width -= it->first_visible_x - it->current_x;
 	  eassert (width > 0);
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = object;
       /* FIXME: It would be better to use TYPE_MAX here, but
@@ -28026,6 +32881,17 @@ append_glyphless_glyph (struct it *it, int face_id, bool for_no_font, int len,
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->hpos = it->hpos;
+      glyph->bytepos = IT_BYTEPOS (*it);
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -29076,10 +33942,20 @@ x_insert_glyphs (struct window *w, struct glyph_row *updated_row,
 
   /* Write the glyphs.  */
   hpos = start - row->glyphs[updated_area];
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (!mc_redraw_row (w, w->current_matrix, row, updated_area, w->output_cursor.x,
+                      hpos, hpos + len, false, DRAW_NORMAL_TEXT, X_INSERT_GLYPHS))
   draw_glyphs (w, w->output_cursor.x, row, updated_area,
 	       hpos, hpos + len,
 	       DRAW_NORMAL_TEXT, 0);
 
+/* *************************************************************************** */
+
+
   /* Advance the output cursor.  */
   w->output_cursor.hpos += len;
   w->output_cursor.x += shift_by_width;
@@ -29505,9 +34381,19 @@ x_fix_overlapping_area (struct window *w, struct glyph_row *row,
 	  while (i < row->used[area]
 		 && row->glyphs[area][i].overlaps_vertically_p);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      if (!mc_redraw_row (w, w->current_matrix, row, area, start_x, start, i,
+          false, DRAW_NORMAL_TEXT, X_FIX_OVERLAPPING_AREA))
 	  draw_glyphs (w, start_x, row, area,
 		       start, i,
 		       DRAW_NORMAL_TEXT, overlaps);
+
+/* *************************************************************************** */
+
+
 	}
       else
 	{
@@ -29758,10 +34644,17 @@ display_and_set_cursor (struct window *w, bool on,
   new_cursor_type = get_window_cursor_type (w, glyph,
 					    &new_cursor_width, &active_cursor);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   /* If cursor is currently being shown and we don't want it to be or
      it is in the wrong place, or the cursor type is not what we want,
      erase it.  */
   if (w->phys_cursor_on_p
+      && NILP (BVAR (XBUFFER (w->contents), crosshairs))
+      && NILP (BVAR (XBUFFER (w->contents), fc_visible))
+      && NILP (BVAR (XBUFFER (w->contents), mc_conf))
       && (!on
 	  || w->phys_cursor.x != x
 	  || w->phys_cursor.y != y
@@ -29774,6 +34667,9 @@ display_and_set_cursor (struct window *w, bool on,
 	      && new_cursor_width != w->phys_cursor_width)))
     erase_phys_cursor (w);
 
+/* *************************************************************************** */
+
+
   /* Don't check phys_cursor_on_p here because that flag is only set
      to false in some cases where we know that the cursor has been
      completely erased, to avoid the extra work of erasing the cursor
@@ -29792,9 +34688,19 @@ display_and_set_cursor (struct window *w, bool on,
       w->phys_cursor.vpos = vpos;
     }
 
-  FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
-                                     new_cursor_type, new_cursor_width,
-                                     on, active_cursor);
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (NILP (BVAR (XBUFFER (w->contents), crosshairs))
+      && NILP (BVAR (XBUFFER (w->contents), fc_visible))
+      && NILP (BVAR (XBUFFER (w->contents), mc_conf)))
+    FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y, new_cursor_type,
+                                       new_cursor_width, on, active_cursor);
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -29887,7 +34793,18 @@ draw_row_with_mouse_face (struct window *w, int start_x, struct glyph_row *row,
 #ifdef HAVE_WINDOW_SYSTEM
   if (FRAME_WINDOW_P (XFRAME (w->frame)))
     {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      if (!mc_redraw_row (w, w->current_matrix, row, TEXT_AREA, start_x,
+                          start_hpos, end_hpos, false, draw, DRAW_ROW_WITH_MOUSE_FACE))
       draw_glyphs (w, start_x, row, TEXT_AREA, start_hpos, end_hpos, draw, 0);
+
+/* *************************************************************************** */
+
+
       return;
     }
 #endif
@@ -31945,11 +36862,23 @@ expose_area (struct window *w, struct glyph_row *row, XRectangle *r,
   struct glyph *last;
   int first_x, start_x, x;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   if (area == TEXT_AREA && row->fill_line_p)
+    {
+      if (!mc_redraw_row (w, w->current_matrix, row, area, 0, 0, row->used[area],
+                          false, DRAW_NORMAL_TEXT, EXPOSE_AREA_ONE))
     /* If row extends face to end of line write the whole line.  */
     draw_glyphs (w, 0, row, area,
 		 0, row->used[area],
 		 DRAW_NORMAL_TEXT, 0);
+    }
+
+/* *************************************************************************** */
+
+
   else
     {
       /* Set START_X to the window-relative start position for drawing glyphs of
@@ -31981,11 +36910,23 @@ expose_area (struct window *w, struct glyph_row *row, XRectangle *r,
 	  ++last;
 	}
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
       /* Repaint.  */
-      if (last > first)
+      /* Floating fake cursors will exist when (last == first). */
+      if (!mc_redraw_row (w, w->current_matrix, row, area, first_x - start_x,
+                          first - row->glyphs[area], last - row->glyphs[area],
+                          false, DRAW_NORMAL_TEXT, EXPOSE_AREA_TWO)
+          && last > first)
 	draw_glyphs (w, first_x - start_x, row, area,
 		     first - row->glyphs[area], last - row->glyphs[area],
 		     DRAW_NORMAL_TEXT, 0);
+
+/* *************************************************************************** */
+
+
     }
 }
 
@@ -31999,10 +36940,22 @@ expose_line (struct window *w, struct glyph_row *row, XRectangle *r)
 {
   eassert (row->enabled_p);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   if (row->mode_line_p || w->pseudo_window_p)
+    {
+      if (!mc_redraw_row (w, w->current_matrix, row, TEXT_AREA, 0, 0,
+                          row->used[TEXT_AREA], false, DRAW_NORMAL_TEXT, EXPOSE_LINE))
     draw_glyphs (w, 0, row, TEXT_AREA,
 		 0, row->used[TEXT_AREA],
 		 DRAW_NORMAL_TEXT, 0);
+    }
+
+/* *************************************************************************** */
+
+
   else
     {
       if (row->used[LEFT_MARGIN_AREA])
@@ -32550,6 +37503,22 @@ x_intersect_rectangles (XRectangle *r1, XRectangle *r2, XRectangle *result)
 void
 syms_of_xdisp (void)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  defsubr (&Smc_dump_glyph_row);
+
+  defsubr (&Smc_dump_glyph_matrix);
+
+  defsubr (&Smc_current_column);
+
+  defsubr (&Smc_stderr);
+
+/* *************************************************************************** */
+
+
   Vwith_echo_area_save_vector = Qnil;
   staticpro (&Vwith_echo_area_save_vector);
 
